const Pth = require('./Pth')

class DStr {
  static clone (obj) { 
    return clone_object(obj, new Pth(), null) 
  }
  static setvalue (obj, pth, value) {
    return clone_object(obj, pth, value)
  }
  
  static getvalue (obj, pth) {
    return myget (obj, pth)
  }

  static encode(obj) {
    return JSON.stringify(obj)
  }

  static decode(txt) {
    return new DStr (JSON.parse(txt))
  }
  
  static sample() {
    const pth = new Pth('x.xa[1]')
    console.log(pth)
    console.log(pth.str())
    console.log(pth.good())



    const a = { a:'za', x: {xa:[9,10,11,12], fcn:function(){}, xb:80 } }
    console.log(a)

    console.log(DStr.clone())

    console.log('pth=',pth.str(),'value=',DStr.getvalue(DStr.clone(),pth))
    console.log(DStr.setvalue(DStr.clone(),pth,1013))
  }

}
module.exports = DStr

// ===== Private utilities =====


function is_atom (obj) {
  const typ = typeof obj
  return typ === 'number' || typ === 'boolean' || typ === 'string' || obj === null
}
function is_array (obj) {
  return Array.isArray(obj)
}

function is_object (obj) {
  return typeof(obj) === 'object'
}

function is_function (obj) {
  return typeof(obj) === 'function'
}

function myget (obj, pth) {
  if (obj!==undefined) {
    if (pth.activekey_array().length>0) {
      return obj[pth.activekey_array()]
    } else if (pth.activekey_object().length>0) {
      return obj[pth.activekey_object()]
    } else {
      return myget (obj[pth.head()], pth.tail())
    }
  } else {
    return undefined
  }
}


function clone_object (obj, pth, value) {
  if (is_atom(obj)) {
    return obj
  } else if (is_array(obj)) {
    let result=[]
    for (let subobj of obj) {
      result.push(clone_object(subobj,pth.tail(),value))
    }
    const key=pth.activekey_array()
    if (key.length>0) {
      console.log('heiii')
      result[key] = value
    }
    return result
  } else if (is_function(obj)) {
    return undefined
  } else if (is_object(obj)) {
    let result = {}
    for (let key of Object.keys(obj)) {
      const subobj=clone_object(obj[key],pth.tail(),value)
      if (subobj!==undefined) {
        result[key] = subobj
      }
    }
    const key=pth.activekey_object()
    if (key.length>0) {
      result[key] = value
    }
    return result    
  } else {
    return undefined
  }
}

/*
function extract_branch_recursive (obj, pth) {
  let result = {}
  let trg = result;
  while (pth.length()>0) {
    let subobj = obj[pth.head()]
    if (subobj!==undefined) {
      if (is)
      const newobj = Object.clone({}, 
    }
  }
  
  
  const head = pth.head
  const tail = pth.tail
  if (head!==undefined) {
    retur
  } else {
    return trg
  }
  if (pth.empty)
  
}
*/