const Util =  require('./Util')


class Pth {
  
  constructor(txt='') {
    this.arr = Util.split_jspath(txt)
  }

  toString () {
    return "Pth:"+this.str()
  }

  length() {
    return this.arr.length
  }
  
  head() {
    return this.arr[0]
  }

  tail() {
    let result = new Pth()
    result.arr = this.arr.slice(1)
    return result
  }

  push(leaf) {
    this.arr.push(leaf)
  }
  
  isleaf () {
    return this.arr.length==1
  }
  
  activekey_array () {
    if (this.isleaf() && Util.is_digits(this.head())) {
      return this.head()
    } else {
      return ''
    }
  }
  activekey_object () {
    if (this.isleaf() && Util.is_alphanum(this.head())) {
      return this.head()
    } else {
      return ''
    }
  }

  str() {
    let result=this.arr.slice(0,1)
    for (let s of this.arr.slice(1)) {
      if (Util.is_digits(s)) {
        result += '['+s+']'
      } else {
        result += '.'+s
      }
    }
    return result
  }
  
  good() {
    for (let key of this.arr) {
      if (!Util.is_alphanum(key)) {
        return false
      }
    }
    return true
  }
  
  static sample() {
    const pth = new Pth('x.xa[1]')
    console.log(pth)
    console.log(pth.str())
    console.log(pth.good())


  }
}
module.exports = Pth

// ===== Private utilities =====

